-- $Name:Signal$
-- $Version:0.1.3$
-- $Author:Valey$

instead_version "1.9.0"

require "para" -- для оформления
require "dash"
require "quotes"
require "xact"
require "hideinv" --скрывает инвентарь в диалогах.
require "wroom"
require "sound"
require "timer"
--require "dbg" -- для отладки

 
game.act = 'Гм...';
game.use = 'Не сработает.';
game.inv = 'Зачем это мне?';

global { 
	state_da = false;   -- Состояние диагностического аппарата
	state_panel_cp = false;	 -- Состояние панели управления
	state_laser = false;		-- Состояние Лазера
	state_WR046 = false;		-- Состояние робота WR046
	state_WR047 = 'null';
	panel_cp_state = false;		-- состояние щитка
	card_state = false;		-- состояние щитка
	state_man = 'кошмар';		-- Состояние человека в капсуле
    gleb_sleep = 'null';			-- переменные для сна
    thompson_sleep = 'null' ;
    ralph_sleep = 'null';
    commander_sleep = 'null';		   
	first_sleep = false;	
	track_name = 'sample1-1.ogg';	
	track_loop = 1;
	track_flag = true;
	ralph		= 'null';
	gleb		= 'null';
	thompson	= 'null';
	commander   = 'null';	
}
 
 
game.timer = function(s)		
	if not is_music() or track_flag == true
		then									
		set_music('mus/'..track_name, track_loop);		
		track_flag = false
			if track_name == 'sample2-2.ogg'	
				then	track_name = 'sample2-3.ogg';
						track_loop = 0
			end;	
		end;
	
end


function init()
        timer:set(1000)
end


main = room {
	nam = 'Сигнал',
	pic = 'gfx/start.png';
	dsc = [[Игра изначально готовилась к ИНСТЕДОЗ 3: Последний рейс.^
			Но по обстоятельствам напрямую зависящих от автора, игра выходит только сейчас, и в не полном оформлении.^^^
			Автор: Valey^^
			Графика: Websterroc^^
			Музыка: ^
			Lauge & Baba Gnohm - H2O ^
			Captain Panic! - Dark Energy ^
			Kai Engel - Moonlight Reprise ^
			]],
	--way = { 'prolog' },
	obj = {vway('Начать игру.', txtc('{Далее}.'), 'start')},
};

start = room {
	nam = 'Начало',
	dsc = [[ Шел 365 день вахты обслуживающего робота WR047. 
	Уже около месяца ему поступали странные сигналы из блока криокапсул, что осложняло его работу. 
	Разобраться с этим не представлялось возможным из-за протоколов невмешательства в работу криокапсул. 
	Показатели погруженных в сон людей оставались в пределах нормы. 
	Так что какие-либо действия со стороны робота были строго запрещены.]],
	--way = { 'prolog' },
	obj = {vway('Пролог', txtc('{Далее}.'), 'tool_storage')},
};


tool_storage = room {
	--entered = code [[ shelf_tools.screwdriver:enable()  ]],
		entered = function()	
				 	track_name = 'sample1-2.ogg';
					track_loop = 1;
				end;
	var {
		swordsman = 0; --фехтование с дверью прошло успешно
		screwdriver = 0; --Отвертка
		relay = 0; --реле
		laser = 2; --Сварочный лазер

	};
	nam = 'Склад инструментов',
	pic = 'gfx/tool_storage.png';
	dsc = function(s)
			if tool_storage.relay == 1
				then p	[[Вставив реле в щиток вас ослепила вспышка и раздался оглушительный треск. Вы рухнули на пол. Через пару минут вы поднялись.]];
				else p	[[Вы находитесь на складе инструментов.]];
				end;
			end;
	obj = {'door_tool_storage','electrical_panel','shelf_spare_parts','shelf_tools','laser_welding','screwdriver','relay','signal'};
};

relay = obj{
	nam = 'Реле';
	dsc = function(s)
		if tool_storage.screwdriver == 0
		then p [[Рядом с отверткой лежит только что собранное {реле}.]];
		else p [[На полу лежит {реле}.]];
		end;
	end;
  --tak = [[Вы подняли реле.]];	
    tak = function(s)
	  p [[Вы подняли реле.]];	
	  tool_storage.relay = 3
	end;  
	inv = [[Реле учета и экономии энергопотребления. В первоначальных расчетах потребление энергии была погрешность, теперь экономить энергию приходится таким образом.]];	
	use = function(s, w)
		if w == electrical_panel  then
			tool_storage.relay = 1;
			remove(s, me());
			walk(tool_storage);
		else p 'Каким образом я должен это сюда прикрутить.'
		end;
	end;
};

screwdriver = obj{
	nam = 'Отвертка';
	dsc = function(s)
			if tool_storage.screwdriver == 0
			then p [[На полу лежит {отвертка}.]];
			else p [[На стеллаже лежит {отвертка}.]];
			end;
		end;
	inv	= [[Обычная отвертка. Даже покорив космос, и уйдя так далеко в прогрессе, отвертка осталась незаменимым инструментом.]];
    tak = function(s)
          p [[Вы взяли отвертку.]];	
          tool_storage.screwdriver = 1
          end;
  	use = function(s, w)
			if w == shelf_tools  then
				p 'Вы положили отвертку на стеллаж.'
				drop(s,shelf_tools)
				tool_storage.screwdriver = 2
			elseif w == shelf_spare_parts 
			then p 'Бьюсь об заклад она тут быть не должна.'
			elseif w == door_tool_storage and tool_storage.swordsman==0
			then p 'Туше дверь! - крикнули вы и тыкнули дверь отверткой. Господи, что же я делаю!'
					tool_storage.swordsman=1
			elseif w == door_tool_storage and tool_storage.swordsman==1
			then p 'Хватит заниматься ерундой.'
			elseif w == electrical_panel and tool_storage.relay == 1
			then p 'Немного магических манипуляций отверткой и все встало как надо.';
					tool_storage.relay = 2
			elseif w == electrical_panel and tool_storage.relay == 0
			then p 'Он уже открыт.'
			else p 'Не зачем это разбирать.'
			end;
		end;
};

laser_welding = obj{
	nam = 'Лазерная сварка';
	dsc = function(s)			
			if tool_storage.laser == 2
			then p [[На стеллаже лежит {лазерная сварка}.]];
			else p [[ERROR!!!]];
		end;
		end;

	inv	= [[Просто удобная вещь: и заварить, и запаять можно, ну или что-нибудь разрезать.]];
	tak = function(s)
		  p [[Вы подняли сварку.]];	
		  tool_storage.laser = 1
		  end;	
	use = function(s, w)
			if w == shelf_tools  then
				p 'Вы положили лазерную сварку на стеллаж.'
				drop(s,shelf_tools)
				tool_storage.laser = 2;
			elseif w == shelf_spare_parts 
			then p 'Бьюсь об заклад она тут быть не должна.'
			elseif w == door_tool_storage 
			then p 'Незачем портить дверь.'
			elseif w == electrical_panel
			then p 'Я думаю это печально закончиться.'  
			elseif w == panel_cp and panel_cp_state == false
			then p [[Вы срезали часть щитка, и он открылся.]];
				 state_panel_cp = true;	
				 track_name = 'sample2-2.ogg';
				 track_loop = 1;
				 panel_cp_state = true
			elseif w == panel_cp and panel_cp_state == true
			then p [["Не будь эгоистом,- сказали вы себе, - вдруг другим роботам тоже захочется тут порезать. Оставим им тоже место".]];				 
			elseif w == control_panel_obj
			then p [[Вы швырнули лазерную сварку в панель, управления и точно попали в открытый щиток.]];
				-- state_panel_cp = false;	
				 state_da = false;
				 state_WR047 = 'несброс';		
				remove(laser_welding, inv());				 
				remove(main_cable, inv());
				path('Войти в диагностический аппарат'):enable();
				path('Подойти к панели управления'):enable();
				path('Выход в коридор'):enable();
			elseif w == cryocapsules_23_cp	
				then p [[Вы с размаху ударили по панели управления, она вспыхнула и погасла. 
						Лазерная сварка осталась в ней. Криокапсула отключилась.]];
						remove(laser_welding, inv());
						state_man = 'убит';
						signal:disable();	
						track_name = 'sample1-5.ogg';
						track_loop = 1;
			else p 'Испепелить бы это, но нельзя.'
			end;
		end;	
		
};

shelf_tools = obj{
	nam = 'Стелажж с инструментами';
	dsc = [[Справа от вас стоит {стеллаж} с инструментами.]];
	act	= [[Место где хранятся инструменты.]];
			
};

shelf_spare_parts = obj{
	nam = 'Шкаф с запчастями';
	dsc = [[Слева от вас находится {шкаф} с запчастями.]];
	act	= [[Место где хранятся запчасти.]];
			
};

door_tool_storage = obj{
	nam = 'Дверь';
	dsc = function(s)
			if here() ==  corridor 
			then p [[Сзади вас {дверь} ведущая на склад инструментов.]];
			else p [[Перед вами {дверь} ведущая в коридор.]];
			end;
		end,		
	act	= function(s)
			if here() ==  corridor  and state_laser == true and state_WR047 ~= 'сброс' 
			then p [[Что-то мне тут может пригодиться.]];
					path('На склад'):enable();
			elseif here() ==  corridor  
			then p [[Там мне делать больше нечего.]];
			elseif tool_storage.relay ~= 2
			then p [[Прежде чем уйти, надо закончить дела.]];
			elseif  state_laser == true and tool_storage.screwdriver == 2
			then  walk (corridor);
			elseif  tool_storage.laser == 2 and tool_storage.screwdriver == 2
			then  walk (corridor);
			else p [[Прежде чем уйти надо положить вещи на свои места.]];
		    end;
		  end;
			
};

electrical_panel = obj{
	nam = 'Электрический щиток';
	dsc = function(s)
			if tool_storage.relay == 1
			then p [[Справа от двери искрит электрический {щиток}, в нем стоит реле.]];
			else p [[Справа от двери находиться электрический {щиток}.]];
			end;
		   end;
	act	= function(s)
			if tool_storage.relay == 1
			then p [[Произошло короткое замыкание. Не правильно соединил контакты.]];
			else p [[Отсюда ведется управление питанием в этой комнате.]];
			end;
		   end;
			
};

signal = obj {
        nam = 'Сигнал';
        var { 
			 state = 0 		
			 };
        act = function(s)
				s.state = s.state + 1
                if s.state > 3 then
                        s.state = 1
                end;
				
				if here() == cryocapsules
					then p[[Исследуя сигнал вы определили, что он идет от криокапсулы № 23.]];
						 path('Капсула 23'):enable();
				elseif here() == cryocapsules_23
					then p[[Как же я устал от этого сигнала.]];	 
				else local act = {
					" Этот сигнал не дает нормально работать!",
					" Может мне спалить себе модуль приема сигналов?!",
					" Когда же закончится моя вахта!",
					};
					p(act[s.state])
				end;

				
        end;
		 
		dsc = function(s)
			if here() ==  corridor 
			then p [[{Сигнал} поступает оттуда.]];
			else p [[Вы принимаете {сигнал} от криокапсулы.]];
			end;
		end,
};

diagnostic = obj{
	nam = 'Комната диагностики';
	dsc = [[В левом конце коридора находится комната {диагностики},]];
	act	= function(s)
			p [[Если вдруг во время вахты выявится неполадка, то там можно ее найти и исправить.]];			
			if state_WR047 ~= 'сброс' 
				then path('В комнату диагностики'):enable();
			end;
		  end;	
};

blocks_obj = obj{
	nam = 'Общие блоки';
	dsc = [[ там же находятся общие {блоки}.]];
	act	= function(s)
		p [[Место, где роботы прибывают в гибернации. "Я уже могу начинать готовиться сдать вахту".]];
		path('В общие блоки'):enable();
	  end;			
};

cryocapsules_obj = obj{
	nam = 'Криокапсулы';
	dsc = [[ В правом конце находятся {криокапсулы}.]];
	act	= function(s)
		p [[Там прибывают во сне члены экипажа.]];
		if state_WR047 ~= 'сброс' 
			then path('К криокапсулам'):enable();
		end;
	  end;			
};

corridor = room {
	entered = function()	
				if from() == diagnostic_room
					then track_flag = true;
						 track_name = 'sample1-4.ogg';
						 track_loop = 0;
					end;
				if track_name == 'sample1-2.ogg'
			 		then track_name = 'sample1-3.ogg';
						 track_loop = 1;
				elseif track_name ~= 'sample1-5.ogg'						 					
					then track_name = 'sample1-4.ogg';
						 track_loop = 0;
				end;
			end;
	enter = function(s ) 
				if state_WR047 == 'сброс' 
					then path('На склад'):disable();
 						 path('К криокапсулам'):disable();
 						 path('В комнату диагностики'):disable();
						 signal:disable();				
				end;
			end;
	nam = 'Коридор',
	pic = 'gfx/corridor.png';
	dsc = function(s)
				if state_WR047 == 'сброс'  
					then p [[Вы находитесь в коридоре. Настройки ПО возвращены по умолчанию. Вы больше не принимаете сигнал. Ваша вахта подошла к концу.]];
					else p [[Вы находитесь в коридоре.]];
				end;
		   end;
	way = {  vroom('В комнату диагностики', 'diagnostic_room'):disable(); vroom('В общие блоки', 'blocks'):disable(); vroom('К криокапсулам', 'cryocapsules'):disable(); vroom('На склад', 'tool_storage'):disable();},
	obj = { diagnostic , blocks_obj, door_tool_storage,cryocapsules_obj,signal},
};


blocks = room{
	nam = 'Общие блоки';
	pic = 'gfx/blocks.png';
	dsc = [[ Вы вошли в общие блоки.]];
	way = { 'corridor'; vroom('Войти в гибернацию', 'Hibernate'):disable(); };
	obj	= {    
			obj {
				   nam = 'Двери';
				   dsc = [[Вы видите много пронумерованных {дверей}.]];
				   act = function(s) 
							if state_WR046 == false 
							then p [[Двери, за которыми находятся в гибернации другие роботы обслуживания.]];
							else p [[Двери, за которыми находятся в гибернации другие роботы обслуживания, кроме WR046, хотя кто знает, может и не только его уже нет.]];
							end;
						 end;
                };
			obj {
				   nam = 'Дверь 47';
				   dsc = [[Ближе к концу коридора по левой стороне вы видите {дверь} с надписью WR047.]];
				   act = function(s) 
							p [[Дверь моего бокса. Войдя туда, я перейду в состояние гибернации.]];
							path('Войти в гибернацию'):enable();
						 end;
                };
		   };			
};




diagnostic_appartus_obj = obj{
	nam = 'Диагностический аппарат';
	dsc = [[ В центре комнаты стоит {диагностический аппарат}.]];
	act	= function(s)
		p [[С его помощью роботы выявляют неисправности.]];
		if state_WR047 ~= 'диагностика' 
			then
				path('Войти в диагностический аппарат'):enable();
			end;
	  end;			
};

arm_diagnostic_appartus = obj{
	nam = 'Манипуляторы диагностического аппарата';
	dsc = function(s)	
		if state_WR047 == 'диагностика' 
			then p [[Вы схвачены {манипуляторами} и висите под потолком.]];
			else p [[Под потолком над ним закреплены два {манипулятора}.]];
		end;
	  end;	
	act	= function(s)
		p [[Разбирают, собирают, режут и паяют. В общем, мастера на все руки.]];		
	  end;			
};

control_panel_obj = obj{
	nam = 'Панель управления диагностическим аппаратом';
	dsc = [[ Возле стены расположилась {панель управления} диагностическим аппаратом.]];
	act	= function(s)		
		p [[С помощью него роботы выявляют неисправности.]];
		if state_WR047 ~= 'диагностика' 
			then
				path('Подойти к панели управления'):enable();
			end;
	  end;			
};

shelf_modules = obj{
	var {take_PCB_cp = false};
	nam = 'Шкафы с запасными модулями.';
	dsc = [[Напротив стоят {шкафы} с запасными модулями.]];
	act	= function(s)
			if state_WR047 == 'диагностика' 
			then 	p [[Не могу дотянуться.]];	
			elseif state_panel_cp ==true and shelf_modules.take_PCB_cp == false
				then p[[Просмотрев стеллажи еще раз, вы нашли нужную плату для ремонта.]];	
					take(PCB_cp);
					shelf_modules.take_PCB_cp = true;
				elseif shelf_modules.take_PCB_cp == true
				then p[[Я думаю, что в шкафах я уже точно ничего нового не найду.]];	
				else p[[Механические запчасти, платы и прочее.]];		
				end;
		  end;
};

PCB_cp = obj{
	nam = 'Плата для панели управления';	
	inv	= [[С ее помощью я смогу починить панель управления.]];
	use = function(s,w)
			if w == panel_cp 
				then state_da = true;
				p[[Плата встала как родная, панель начала оживать.]]
				remove(s, me());
			end;
		  end;
};

box_broken_modules = obj{
	nam = 'Коробки со сломанными модулями.';
	dsc = [[В дальнем углу стоят {коробки} со сломанными модулями.]];
	act	= function(s)
			if state_WR047 == 'диагностика'
			then 	p [[Не могу дотянуться.]];			
			elseif state_WR047 == 'несброс' and card_state == false and state_WR046 == true
				then p [[В коробках вы нашли останки робота WR046. Покопавшись, еще вы извлекли оттуда ключ доступа к криокамерам.]];
				take(passkey);
				card_state = true
				else p [[Сломанные платы и модули не выкидываются, а описываются и складируются.]];
			end;	
		  end;			
};

passkey = obj{
	nam = 'Ключ доступа';	
	inv	= [[Ключ доступа, к криогенным камерам экипажа.]];
	use = function(s,w)
			if w == cryocapsules_23_cp 
				then p[[Вы подключились к панели управления криокапсулой и теперь можете подключиться к сну человека.]]
					 path('Войти в сон'):enable();
					 remove(s, me());
			end;
		  end;
};

monitor_cp = obj{
	nam = 'Монитор на панели управления.';
	dsc = [[В центре панели управления располагается большой {монитор}.]];
	act	= function(s)
			if state_da == false 
				then p [[В темном мониторе вы видите свое отражение.]];
				else p [[Данные по диагностике обслуживающего робота WR046.^^
						При диагностике обслуживающего робота WR046, были выявлены изменения в ПО робота, 
						а также были выявлены изменения в оборудовании робота. На правом манипуляторе появился ключ доступа подключения к криогенным камерам экипажа.^
						На вопрос, об изменениях в оборудовании робота и его ПО, обслуживающий робот WR046 начал рассказывать про некий сигнал от одной из криокапсул. 
						И что данные изменения были сделаны им лично для подключения к криокапсуле, чтобы разобраться в причинах странного сигнала.
						В ответ на предложение вернуть ПО и оборудование робота к изначальным установкам был получен категорический отказ
						и была осуществлена попытка взять под контроль диагностический аппарат.^
						В соответствии с протоколами о невмешательстве в работу криокапсулы, а также общем стандарте для обслуживающих роботов.
						Была произведена насильная попытка вернуть обслуживающему роботу WR046 стандартное ПО и комплектацию.^
						Оказав сопротивление обслуживающий робот WR046 был дезинтегрирован, описан и отправлен в отработанный материал.^
						В ходе данной операции было поврежден стабилизатор напряжения на панели управления. Возможно перегорание печатных плат.....
						]];
						state_WR046 = true;
			end;				
	  end;			
};

button_cp = obj{
	nam = 'Кнопки на панели управления.';
	dsc = [[Вокруг него расположены много разных {кнопок}, ]];
	act	= function(s)
			if state_da == false 
				then p [[Вы понажимали на кнопки, никакой реакции в ответ вы не получили.]];
				elseif  state_WR046 == false
				then p [[Вы понажимали на кнопки и на экране высветились данные по последней диагностике перед отключением системы.]];					
				else p [["Один уже донажимался, я не хочу повторить его судьбу".]];
			end;				
	  end;			
};

lamp_cp = obj{
	nam = 'Лампы на панели управления.';
	dsc = [[и еще больше разных {лампочек}.]];
	act	= function(s)
			if state_da == false 
				then p [[Панель безжизненна, лампочки не горят.]];
				else p [[Если бы у меня вместо оптических модулей были глаза людей, то в них бы точно начало рябить от такого светопредставления.]];
			end;				
	  end;			
};


panel_cp = obj{
	nam = 'Щиток на панели управления.';
	dsc = function(s)
			if state_panel_cp == false 
				then p [[Сбоку внизу на панели вы видите закрытый {щиток}.]];
				else p [[Сбоку внизу на панели вы видите открытый {щиток}.]];
			end;	
		  end;
	act	= function(s)
			if state_panel_cp == false 
				then p [[Крепко накрепко закрыт. Чем бы его открыть или разрезать?]];
			elseif state_panel_cp == true and state_da == false 
				then p [[Щиток открыт. Внутри вы видите поврежденные платы. ]];
				else p [[Щиток открыт. После замены плат, все работает.]];	
			end;	
			if state_laser ==false 
				then state_laser = true;
				end;
		  end;	

};




control_panel = room{
	nam = 'Панель управления';
	dsc = [[Вы стоите возле панели управления.]];
	way = {  wroom('Отойти от панели', 'diagnostic_room');},
	obj = { monitor_cp, button_cp, lamp_cp, panel_cp},
};

button_start_diagnosis = obj{
	nam = 'Кнопка запуска диагностики.';
	dsc = [[Кабина довольна тесная. Перед собой вы видите несколько экранов, разнообразных портов, лампочек 
			и большую {кнопку} начала диагностики.]];
	act	= function(s)
			if state_da == false 
					then p [[Вы нажали на кнопку. Но ничего не произошло. Видать какие то неполадки в самом диагностическом аппарате. 
						Сапожник без сапог, вспомнили вы изречение людей.]];
				elseif state_WR047 == 'диагностика' 
					then p [[Аппарат уже провел диагностику и ждет от вас действия.]];
				else p [[Вы нажали на кнопку. Аппарат начал работу. К вашим интерфейсам были подключены кабеля, 
						началось сканирование системы. Попутно манипуляторы начали проверку оборудования. Проверка шла 
						по обычному сценарию, как вдруг на экране высветилось, что в программном обеспечении присутствует чужеродный код.
						Аппарат попросил вас подключить главный кабель к центральному хранилищу для возврата ПО к настройкам по умолчанию.]];
						state_WR047 = 'диагностика';
						take(main_cable); 
						port_central_repository:enable();
			end;
		  end;			
};

port_central_repository = obj{
	nam = 'Порт центрального хранилища.';
	dsc = [[Перед вами открылась панелька, за которой находится {порт} центрального хранилища.]];
	act	= [[После подключения к нему, я буду возвращен к настройкам по умолчанию.]];
};

main_cable = obj{
	nam = 'Главный кабель';
	inv = [[Мой главный кабель по протоколам защиты обслуживающих роботов, только я принимаю решение о доступе к моему ядру.]];
	use	= function(s, w)
			if w == port_central_repository 
				then p [[Вы подключили главный кабель, к центральному хранилищу. И через мгновение все погасло.]];
						state_WR047 = 'сброс';
						remove(s, me());
						remove(laser_welding, inv());
						walk(corridor);		
						track_name = 'sample1-5.ogg';
						track_loop = 1;				
				else p [[Я не уверен в правильности своих действий, возможно, мое ПО слишком сильно неисправно.]];						
			end;
	  end;			
};

diagnostic_appartus = room{
	entered = code [[ port_central_repository:disable() ]];
	nam = 'Кабина диагностического аппарата';
	dsc = [[Вы вошли в кабину диагностики.]];
	way = { 'diagnostic_room'},
	obj = { button_start_diagnosis, port_central_repository },
	exit = function ()
			if state_WR047 == 'диагностика' and state_man == 'убит'
			then 	state_WR047 ='дезинтегрирован'
					walk(Hibernate);
			end;
	end;
};


diagnostic_room = room{
	entered = function ()
				if from() ~= 'corridor' or  state_WR047 ~= 'несброс' or state_WR047 ~= 'сброс'
					then
						track_flag = true
						if  state_panel_cp == false
							then
							track_name = 'sample2-1.ogg';
							track_loop = 0;
						else
							track_name = 'sample2-2.ogg';
							track_loop = 1;
						end;	
				end;		    
			  end;
	nam = 'Комната диагностики';
	pic = 'gfx/diagnostic_room.png';
	dsc = function(s)
			if state_WR047 == 'диагностика'
				then p [[Вы вышли из кабины диагностического аппарата и тут же были схвачены манипуляторами диагностического аппарата.]];
				path('Войти в диагностический аппарат'):disable();
				path('Подойти к панели управления'):disable();
				path('Выход в коридор'):disable();
			elseif state_WR047 == 'несброс'
				then p [[Вы находитесь в комнате диагностики. Диагностический аппарат, который вы чинили, опять не работает, благодаря вам.]];
				path('Войти в диагностический аппарат'):enable();
				path('Подойти к панели управления'):enable();
				path('Выход в коридор'):enable();
				else p [[Вы находитесь в комнате диагностики.]];
			end;
		  end;
	way = {  vroom('Подойти к панели управления', 'control_panel'):disable(); vroom('Войти в диагностический аппарат', 'diagnostic_appartus'):disable(); vroom('Выход в коридор', 'corridor'):enable();},
	obj = { diagnostic_appartus_obj, arm_diagnostic_appartus, control_panel_obj, shelf_modules, box_broken_modules },
};


cryocapsules = room{
	nam = 'Блок криокапсул';
	pic = 'gfx/cryocapsules.png';
	dsc = [[ Вы вошли в блоки с криокапсулами.]];
	way = { 'corridor'; vroom('Капсула 23', 'cryocapsules_23'):disable();};
	obj = {
		obj {
			   nam = 'Капсулы';
			   dsc = [[Перед вами по кругу расположены {криокапсулы}. Сквозь полупрозрачные крышки капсул вы видите лица спящих людей.]];
			   act = function(s) 
						if state_man == 'кошмар'
						then p [[Лица людей не выказывают спокойствия, возможно сигнал действует и на них.]];
						elseif state_man == 'убит'
						then p [[Лица людей безмятежны. Сигнал мучал не только вас.]];
						else p [[Лица людей безмятежны.]];
						end;
					 end;
			};
		obj {
			   nam = 'Панель управления';
			   dsc = [[Возле каждой капсулы находится {панель} управления.]];
			   act = function(s) 
						p [[На панелях представлена полная информация о членах экипажа.]];						
					 end;
			};
			signal;
	   };	
};

cryocapsules_23_cp = obj{
	nam = 'Панель управления капсулой №23';
	dsc = [[Справа от вас расположилась {панель} управления криокапсулой.]];	
	act = function(s) 
					if state_man == 'кошмар'
						then p [[Вне сомнений сигнал идет от этой панели. Надо как-то подключиться к этой панели, 
								либо отключить сигнал.]];
						elseif state_man == 'убит'
						then p [[Панель разрушена. Сигнал от нее больше не поступает.]];
						else p [[Панель работает в штатном режиме. Никаких сигналов от нее больше не поступает.]];						
					 end;
		  end;			
};

cryocapsules_23 = room{
	var = { smile = false };
	nam = 'Криокапсула 23';
	dsc = [[ Вы подошли к криокапсуле №23]];
	way = { 'cryocapsules'; vroom('Войти в сон', 'sleep_control_center'):disable(); };
	obj = {
		obj {
			   nam = 'Капсула';
			   dsc = [[Вы стоите рядом с капсулой. Внутри вы видите молодого {человека}.]];
			   act = function(s) 
						if state_man == 'кошмар'
						then p [[На его лице происходит нескончаемая борьба.]];
						elseif state_man == 'убит'
						then p [[В темном окошке криокапсулы, виден силуэт мертвого человека.]];
						elseif cryocapsules_23.smile == false
						then p [[Вы заметили на его лице легкую улыбку, которая тут же исчезла.]];
							 cryocapsules_23.smile = true;
						else p [[Его лицо спокойно и безмятежно, также как и лица других членов экипажа.]];
						end;
					 end;
			};
			cryocapsules_23_cp;
			signal;
	   };	
};

sleep_obj = obj {
	nam = 'Сон.',
	dsc = function(s)
			if first_sleep == false
				then p[[Время от времени члены экипажа выводяться в быструю фазу сна, 
						для того чтобы во время полета их когнитивные функции не деградировали.
						Сейчас человек находиться в быстрой фазе. Но сон зациклился и не дает ему выйти 
						из фазы быстрого сна. Теперь ясна причина сигнала. Такая ошибка не была прописана в протоколах.^^
						]];
						
			elseif state_man == 'сон'
				then p [[Сон человека покинул цикл. Он перешел в глубокую фазу сна. ]]
						track_name = 'sample1-5.ogg';
						track_loop = 1;
			else p[[Вы видите перед собой начало сна. Вы можете повлиять на его содержание. ^]]
				end;
			end;
};

commander_obj = obj{
	nam = 'Командир.';
	dsc = function(s)
				p [[За столом сидит {командир}.]];	
		  end;
	act	= function(s)
			p [[Мужчина в зрелом возрасте. Он напряжен.]];			
			if commander_sleep == 'null' 
				then p [[Его руки крепко сцеплены в замок.]];
			elseif commander_sleep == 'photo' 
				then p [[В руках он держит фоторамку и изредка посматривает на нее.]];
			elseif commander_sleep == 'mail' 
				then p [[В руках он держит письмо и изредка поглядывает на Ральфа.]];
			elseif commander_sleep == 'phone' 
				then p [[В руках он держит телефон.]];
			end;	
			if commander == 'mail' 
				then p [[^У командира есть известия для Ральфа, которые он должен ему передать.]];
			end;
		  end;	
};
thompson_obj = obj{
	nam = 'Пилот стоящий слева.';
	dsc = function(s)
			p [[Слева от Вас, стоит {Томпсон}.]];
		  end;
	act	= function(s)
			p [[Мужчина средних лет. Видно, что он заинтересован этим спонтанным собранием.]];
			if thompson_sleep == 'photo' 
				then p [[В руках он держит фотографию.]];
			elseif thompson_sleep == 'mail' 
				then p [[В руках он держит письмо.]];
			elseif thompson_sleep == 'phone' 
				then p [[В руках он держит телефон.]];
			end;				
			if thompson == 'mail' 
				then p [[^Томпсон хороший семьянин, и он ждет пополнения в семье, так что ни о какой экспедиции не может быть и речи.]];
			elseif thompson == 'family'
				then p [[^Томпсон хороший семьянин, и я не знаю причин способных отправить его в эту экспедицию.]];
			end;		
		  end;	
};
ralph_obj = obj{
	nam = 'Пилот стоящий возле стола.';
	dsc = function(s)
			p [[Возле стола стоит {Ральф}.]];
		  end;
	act	= function(s)
			p [[Молодой парень. Он отрешенно смотрит на все происходящее вокруг.]];
			if ralph_sleep == 'null' 
				then p [[Одной рукой он опирается на стол.]];
			elseif ralph_sleep == 'photo' 
				then p [[Одной рукой он опирается на стол, в другой он держит фотографию.]];
			elseif ralph_sleep == 'mail' 
				then p [[Одной рукой он опирается на стол, рядом с ней лежит письмо.]];
			elseif ralph_sleep == 'phone' 
				then p [[Одной рукой он опирается на стол, в другой он держит телефон.]];
			end;	
			if ralph == 'brother'
				then p [[^У Ральфа нашелся брат. Это не просто хорошие новости, это просто отличные новости. Вас это очень радует.]]
			elseif ralph == 'mail' 
				then p [[^Для Ральфа есть какое-то сообщение, но не понятно какое.]];
			elseif ralph == 'crash' 
				then p [[^Ральф был в аварии. Такое ощущение, что он обозлен на весь мир.]];
			elseif ralph == 'crash_mail' 
				then p [[^Для Ральфа есть какое-то сообщение, но не понятно какое. Интересно, может ли оно как-то смягчить его злобу.]];
			end;
		  end;	
};
gleb_obj = obj{
	nam = 'Пилот друг.';
	dsc = function(s)
			p [[Справа от вас стоит {Глеб}.]];
		  end;
	act	= function(s)
			p [[Ровесник спящего. Он погружен в свои мысли.]];
			if gleb_sleep == 'null' 
				then p [[Его руки убраны в карманы.]];
			elseif gleb_sleep == 'photo' 
				then p [[В руках он держит фотографию.]];
			elseif gleb_sleep == 'mail' 
				then p [[В руках он держит письмо.]];
			elseif gleb_sleep == 'phone' 
				then p [[В руках он держит телефон.]];
			end;
			if gleb == 'friend'
				then p [[^Глеб ваш друг детства.]]
			elseif gleb == 'best_friend' 
				then p [[^Вы с Глебом знакомы с самого детства и вам будет трудно расставаться. Хотелось бы что-нибудь иметь на память.]];			
			end;	
		  end;	
};

photo = obj{
	nam = 'Фотография';
	inv = [[Фотография, с помощью которой я могу влиять на сон.]];
	use	= function(s, w)
			if w == commander_obj 
				then p [[Вы отдали фотографию командиру.]];
				commander_sleep = 'photo';
				remove(photo, inv());
			elseif w == thompson_obj
				then p [[Вы отдали фотографию Томпсону.]];
				thompson_sleep = 'photo';
				remove(photo, inv());
			elseif w == ralph_obj
				then p [[Вы отдали фотографию Ральфу.]];
				ralph_sleep = 'photo';
				remove(photo, inv());
			elseif w == gleb_obj
				then p [[Вы отдали фотографию Глебу.]];
				gleb_sleep = 'photo';
				remove(photo, inv());
					
				else p [[Не совсем ясно что вы пытаетесь сделать с фотографией.]];						
			end;
	  end;			
};
mail = obj{
	nam = 'Письмо';
	inv = [[Письмо, с помощью которого я могу влиять на сон.]];
	use	= function(s, w)
			if w == commander_obj
				then p [[Вы отдали письмо командиру.]];
				commander_sleep = 'mail';
				remove(mail, inv());
			elseif w == thompson_obj
				then p [[Вы дали письмо Томпсону.]];
				thompson_sleep = 'mail';
				remove(mail, inv());
			elseif w == ralph_obj
				then p [[Вы дали письмо Ральфу.]];
				ralph_sleep = 'mail';
				remove(mail, inv());
			elseif w == gleb_obj
				then p [[Вы дали письмо Глебу.]];
				gleb_sleep = 'mail';
				remove(mail, inv());
					
				else p [[Не совсем ясно что вы пытаетесь сделать с письмом.]];						
			end;
	  end;				
};
phone = obj{
	nam = 'Телефон';
	inv = [[Телефон, с помощью которого я могу влиять на сон.]];
	use	= function(s, w)
			if w == commander_obj
				then p [[Вы отдали телефон командиру.]];
				commander_sleep = 'phone';
				remove(phone, inv());
			elseif w == thompson_obj
				then p [[Вы отдали телефон Томпсону.]];
				thompson_sleep = 'phone';
				remove(phone, inv());
			elseif w == ralph_obj
				then p [[Вы отдали телефон Ральфу.]];
				ralph_sleep = 'phone';
				remove(phone, inv());
			elseif w == gleb_obj
				then p [[Вы отдали телефон Глебу.]];
				gleb_sleep = 'phone';
				remove(phone, inv());
					
				else p [[Не совсем ясно что вы пытаетесь сделать с телефоном.]];						
			end;
	  end;			
};

sleep_control_center = room {
	entered = function(s)
				if first_sleep == false 
					then 
						commander_obj:disable();
						thompson_obj:disable();		
						ralph_obj:disable();	
						gleb_obj:disable();	
				elseif state_man == 'сон'	
					then
						commander_obj:disable();
						thompson_obj:disable();		
						ralph_obj:disable();	
						gleb_obj:disable();	
						path('Просмотреть сон'):disable();
				elseif state_man ~= 'сон'
					then
						take(photo);
						take(mail);
						take(phone); 					
					end;
					track_flag = true
				 	track_name = 'sample3-1.ogg';
					track_loop = 0;				
			  end;
	left = function(s)
			remove(photo, inv());
			remove(mail, inv());
			remove(phone, inv());			
		   end;
	nam = 'Центр управления снами';
	dsc = [[Вы находитесь в центре управления снами.]];	
	obj = {sleep_obj; commander_obj; thompson_obj; ralph_obj; gleb_obj;};
	way = {'cryocapsules_23'; vroom('Просмотреть сон', 'sleep'):enable();};
};


sleep = room {
	entered = function(s)
			if first_sleep == false
				then
						first_sleep = true;
						commander_obj:enable();
						thompson_obj:enable();		
						ralph_obj:enable();	
						gleb_obj:enable();
				end;
			if ralph_sleep == 'mail' and commander_sleep == 'phone' and gleb_sleep == 'photo'
				then 
					state_man = 'сон';	
					signal:disable();
				end;
			end;
	nam = 'Сон',
	dsc = function(s)
			p[[Командир собрал нас всех в его кабинете. По его виду заметно, что он хочет сообщить нам что-то важное. ^
				- Итак, ребята, вы слышали про экспедицию к новым мирам. И то, что сейчас идет отбор в члены экипажа.
				Так как вы являетесь летчиками-испытателями новейшей разработки, то был отдан приказ сверху включить в группу пилотов 
				экспедиции одного из вас. ^
				Командир замолчал на некоторое время.^
				- Сейчас нам надо решить кто это будет. ^								
				"Вот так поворот", - подумали вы. ^^
				]];
			if thompson_sleep == 'null'
				then p[[ - Командир, вы знаете что я человек семейный и у меня уже есть дети. И то что из-за семьи я собираюсь уходить 
						из летчиков-испытателей. Так что прошу снять мою кандидатуры с этого полета. - сказал Томпсон.^
						- Да я понимаю, и думаю что никто не будет против из здесь присутствующих. ^
						"Семья, дети, а я ведь так давно об этом мечтал и если улечу даже не знаю, смогу ли там завести семью." - вам стало грустно.^^]];
						if thompson == 'mail' 
							then p[[]];
							else thompson = 'family';
						end;
			elseif thompson_sleep == 'phone' 
				then p [[ - Командир, я не смогу полететь по известным вам причинам, - сказал Томпсон.^
						  - Так как я... - Вдруг его перебил телефонный звонок. Томпсон посмотрел на командира и тот одобряющим взглядом разрешил тому удалиться для разговора по телефону. ^
							Вы проводили взглядом уходящего пилота.]];
			elseif thompson_sleep == 'mail' 
				then p [[ 	Пока командир говорил, Томпсон бегло прочитал письмо и стал просто светиться от счастья.
							- Командир, я не смогу улететь при всем желании, у меня ведь семья, а теперь еще и пополнение, - он помахал письмом, - Целый день не мог прочитать письмо.^ 
							- Ну что, оторвать тебя от семьи мы не имеем права, но скажи, почему такие вещи тебе сообщают письмом? ^ 
							- Электронное сообщение-это просто информация, а письмо будет храниться и перечитываться.^ 
							- Понятно. Ну что, не смею задерживать и прими поздравления. ^ 
							Томпсон быстрым шагом покинул кабинет.^
							"Интересный у него подход к письмам. Он любит свою семью. Эх, и мне бы семью уже завести."  - вам стало грустно.^^]];	
						thompson = 'mail';
			elseif thompson_sleep == 'photo' 
				then p [[ 	- Командир, вы знаете, что я человек семейный и у меня уже есть дети. И то, что из-за семьи я собираюсь уходить 
							из летчиков-испытателей. Так что прошу снять мою кандидатуру с этого полета, - сказал Томпсон, посмотрел на фото в руках и улыбнулся.^
							- Да, я понимаю и думаю, что никто не будет против из здесь присутствующих. ^
							"Семья, дети, а я ведь так давно об этом мечтал и если улечу даже не знаю, смогу ли там завести семью", - вам стало грустно.^^]];
			else p [[Ошибка в переменной thompson_sleep]];
			end;
			if ralph_sleep == 'null'
				then p[[ - Я готов лететь, - сказал Ральф.^
						 - Ты не сможешь лететь. После той трагедии ты все еще не пришел в себя.
						 В доказательство тому авария на ровном месте. Не забывай, что ты находишься под наблюдением врачей. И мы не знаем, как ты перенесешь криосон после операции, - ответил командир.^
						 - Тогда зачем позвали меня и его? - Он кивнул в сторону Глеба.^ 
						 - Он ведь тоже был в той аварии и тоже после операции, - продолжил Ральф.^
						 - Да, я знаю, но вы команда и решение это должно исходить от вас.^
						 "А решения то походу и нет, остался только я" - Вас это расстроило. ^^]];		
						if ralph == 'brother'
							then p [[]]
						elseif ralph == 'mail' or ralph == 'crash_mail' 
							then ralph = 'crash_mail'
							else ralph = 'crash'
						end;				 
			elseif ralph_sleep == 'phone' 
				then p [[ "Я...", - Ральф начал говорить, но его перебил телефонный звонок. Он посмотрел на телефон, жестом попросился выйти и перед уходом сказал: - "Я не против улететь, но это все на ваше усмотрение".^ 
						   Командир, проводив его взглядом сказал: "Он не смог бы все равно полететь из-за недавней аварии и перенесенной операции, как и ты. - 
						   он обратился к Глебу." ^^]];
			elseif ralph_sleep == 'mail' and commander_sleep == 'phone'
				then p [[ - Я готов лететь, - сказал Ральф.^ 
						  - Нет, ты не сможешь пока полететь из-за операции, и еще... - внезапный звонок перебил командира. Он посмотрел на телефон и встал из-за стола.^
						  Направившись в дальний угол комнаты, он жестом указал Ральфу на письмо, лежавшее на столе.^
						  Ральф взял письмо и начал не спеша читать, походу все быстрее и жаднее поглощая его содержимое. Опустив письмо, он посмотрел на собравшихся вокруг.^
						  Командир, закрыв ладонью микрофон на телефоне, сказал ему: "У тебя увольнительная на неделю". ^
						  Ральф пулей вылетел из кабинета, оставив недоумение на лицах остальных пилотов. 
						  Командир опять закрыв микрофон, добавил: "Брата, который полгода назад пропал без вести и считавшийся погибшим, нашли".^
						  Командир продолжил свою беседу:^
						  "Нашелся брат, отличные новости!" Вы порадовались за Ральфа. ^^
						]];
						ralph = 'brother' 
			elseif ralph_sleep == 'mail' 
				then p [[ - Я готов лететь, - сказал Ральф.^ 
						  - Я не могу тебя отправить по двум причинам, - сказал командир^
						  - Во первых, ты только после операции, а вторую причину я скажу после собрания, - командир посмотрел на письмо лежащее на столе.
						  Ральф хотел было что-то сказать но командир жестом прервал его.^
						  "Что еще за причина? Но как бы там не было, если командир говорит так, то значит, так оно и есть." ^^						  
							]];
						if ralph == 'brother'
							then p [[]]
						elseif ralph == 'crash' or ralph == 'crash_mail' 
							then ralph = 'crash_mail'
							else ralph = 'mail'
						end;
			elseif ralph_sleep == 'photo' 
				then p[[ - Я готов лететь, - сказал Ральф. Взглянув украдкой на фото в руке, он стал еще более уверенным в своем решении.^
						 - Ты не сможешь лететь. После той трагедии ты все еще не пришел в себя.
						 В доказательство тому авария на ровном месте. Не забывай, что ты находишься под наблюдением врачей. И мы не знаем, как ты перенесешь криосон после операции. - ответил командир.^
						 - Тогда зачем позвали меня и его? - Он кивнул в сторону Глеба.^ 
						 - Он ведь тоже был в той аварии и тоже после операции.^
						 - Да я знаю, но вы команда и решение это должно исходить от вас.^
						 "А решения то походу и нет, остался только я." - Вас это расстроило. ^^]];	
						if ralph == 'brother'
							then p [[]]
						elseif ralph == 'mail' or ralph == 'crash_mail' 
							then ralph = 'crash_mail'
							else ralph = 'crash'
						end;
			else p [[Ошибка в переменной ralph_sleep]];
			end;
			if gleb_sleep == 'null'
				then p[[ Глеб похлопал вас по плечу. ^
						 - Прости, похоже наши планы о покорении вселенной будешь выполнять ты один, - сказал он.^
						 Я не знаю кто он, но чувствую, что он мне очень дорог, - Вы сильно расстроились.^^ ]];						 
			elseif gleb_sleep == 'phone'
				then p [[ Глеб хотел что-то сказать, но его перебил телефонный звонок. Он отошел в сторону и начал о чем-то беседовать.]];
			elseif gleb_sleep == 'mail'
				then p [[ - Мне немного обидно от того, что я не смогу полететь, но я рад, что полетишь ты, - Глеб повернулся к вам. ^
						  - Вот смотри, что у меня, - он протянул вам письмо, - это наш детский план покорения вселенной, - он грустно улыбнулся. ^
						  Вас позабавил, этот детский, амбициозный план и стало немного грустно за Глеба, вашего хорошего друга.]];
						  if gleb == 'best_friend' or gleb == 'friend'
						  	then p [[]]
						  	else gleb = 'friend'
						  end;
			elseif gleb_sleep == 'photo'
				then p [[ - Мне немного обидно от того, что я не смогу полететь, но я рад, что полетишь ты, - Глеб повернулся к вам, ^
						  - Вот смотри, - он показал вам фотографию, на которой светились от счастья два мальчугана. Присмотревшись вы узнали на фото себя и Глеба. ^
						  - Возьми, - он протянул вам фотографию, - это единственное фото из детства, и я хочу, чтобы там, в пучинах космоса ты не забывал о своей семье.						
						   Вы взяли фотографию, и еще раз посмотрев, аккуратно убрали ее в портмоне. Вам стало немного грустно, но вы были рады, что у вас есть такой друг."]];
						  gleb = 'best_friend';
			else p [[Ошибка в переменной gleb_sleep]];
			end;			
			if commander_sleep == 'null'
				then p[[ Командир посмотрел на вас. ^
						 "Ты извини, но мы не оставили тебе выбора. Можешь начинать сбор. Все свободны!"^ ]];	
			elseif commander_sleep == 'phone'
				then p[[ Командир, заметив, что обсуждение закончилось, сказал: ^
							"Ты извини, но мы не оставили тебе выбора. Можешь начинать сбор. Все свободны!"^ ]];				
			elseif commander_sleep == 'mail'
				then p[[  Командир, покрутив письмо в руках еще немного, отдал письмо пилоту, стоявшему возле стола, и обратился к вам: ^
							"Ты извини, но мы не оставили тебе выбора. Можешь начинать сбор. Все свободны!"^ ]];	
					 commander = 'mail';
			elseif commander_sleep == 'photo'
				then p[[  Командир посмотрел на фотографию на столе, а затем обратился к вам: ^
							"Ты извини, но мы не оставили тебе выбора. Можешь начинать сбор. Все свободны!"^ ]];									
			else p [[Ошибка в переменной commander_sleep]];
			end;
		  end;
	way = {'sleep_control_center';};
	left =function(s)
				commander_sleep = 'null';
				thompson_sleep = 'null';
				ralph_sleep = 'null';
				gleb_sleep = 'null';
	end;
};


Hibernate = room {
	nam = 'Гибернация',
	dsc = function(s)
			if	state_WR047 =='дезинтегрирован'
				then p[[Отказавшись от сброса системы, вы запустили протокол дезинтеграции. Вы были разобраны, описаны и сложены в ящики отходов.  ^ ]];		
			elseif state_WR047 == 'сброс' 
				then p[[Вы спокойно сдали свою вахту. К обслуживанию корабля приступил робот WR048. ^ ]];	
			elseif state_man == 'убит' 
				then p[[Вы завершили жизненный цикл члена экипажа, а вместе с ним прекратили существование сигнала. ^
						Как бы там ни было каждый выбирает свои путь, для поставленной цели.]];							
			elseif state_man == 'сон' 
				then p[[Разобравшись с проблемой сна члена экипажа, вы с чувством выполненного долга, сдали вахту. ^ ]];
			elseif state_WR047 == 'null' and state_WR046 == false
				then p[[Вы сдали свою вахту, не став разбираться в причинах сигнала. ]];	
			elseif state_WR047 == 'null' and state_WR046 == true
				then p[[Вы сдали свою вахту, зная природу существования сигнала, но предпочтя не разбираться в причинах его возникновения. ^
						Вы не могли знать, что робот WR048, не выдержав постоянное давление сигнала, обесточил криокапсулу, откуда шел сигнал. Тем самым прекратив жизненный цикл члена экипажа.]];					
			else p [[Вы сдали свою вахту, бросив начатое дело на полпути.]];
			end;

			p [[^^^^^^^^^Это конец истории об обслуживающем роботе WR047.]];
		  end;	
};


